package ch.devotekit.testit;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.net.URL;
import java.net.URLClassLoader;

public class Reloader {
	public static void main(String[] args) throws IOException,
			ClassNotFoundException, InstantiationException,
			IllegalAccessException, NoSuchMethodException, SecurityException, IllegalArgumentException, InvocationTargetException {
		File classFiles = new File(args[0]);
		URL[] url = new URL[] { classFiles.toURI().toURL() };

		Object instance= null;
		Class<?> clazz= null;
		
		try (URLClassLoader cl = new URLClassLoader(url)) {
			clazz = cl.loadClass(args[1]);
			instance = clazz.newInstance();
			System.out.println("loaded " + String.valueOf(instance));
		}
		try (BufferedReader reader = new BufferedReader(new InputStreamReader(
				System.in));) {
			String command;
			while ((command = reader.readLine()) != null) {
				if (command.startsWith("r")) {
					try (URLClassLoader cl = new URLClassLoader(url)) {
						clazz = cl.loadClass(args[1]);
						instance = clazz.newInstance();
						System.out.println("loaded " + String.valueOf(instance));
					}
				} else if (command.startsWith("d")) {
					Method m= clazz.getMethod("doit");
					m.invoke(instance);
				}
			}
		}
	}
}
